//+------------------------------------------------------------------+
//|                                             Gann HiLo - bars.mq4 |
//|                                                           mladen |
//|                                                                  |
//| Original introduced by Robert Krausz                             |
//| (February 1998, Stocks & Commodities Magazine                    |
//+------------------------------------------------------------------+
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"

#property indicator_chart_window
#property indicator_buffers 2
#property indicator_color1 DodgerBlue
#property indicator_color2 Sienna

//
//
//
//
//

#property  indicator_width1  2
#property  indicator_width2  2

//
//
//
//
//
//
//
//
//
//

extern string TimeFrame = "Current time frame";
extern int    Lb        = 19;

//
//
//
//
//

double hi[];
double lo[];
double Hlv[];

//
//
//
//
//

string indicatorFileName;
bool   calculateValue;
bool   returnBars;
int    timeFrame;

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int init()
{
 IndicatorBuffers(3);
   SetIndexBuffer(0,hi);
   SetIndexBuffer(1,lo);
   SetIndexBuffer(2,Hlv);
   
     //
     //
     //
     //
     //
      
     indicatorFileName = WindowExpertName();
     calculateValue    = (TimeFrame=="calculateValue"); if (calculateValue) return(0);
     returnBars        = (TimeFrame=="returnBars");     if (returnBars)     return(0);
     timeFrame         = stringToTimeFrame(TimeFrame);
      
     //
     //
     //
     //
     //
   
   IndicatorShortName(timeFrameToString(timeFrame)+"  Gann HiLo activator bars");
 return(0);
}

//
//
//
//
//

int deinit(){  return(0); }

//
//
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+

int start()
{
   int counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
           int limit=Bars-counted_bars;
           if (returnBars)  { hi[0] = limit+1; return(0); }
   
   //
   //
   //
   //
   //
   
   if (calculateValue || timeFrame == Period())
   {

       for(int i=limit;i>=0;i--)
       {
         double mah = iMA(Symbol(),0,Lb,0,MODE_SMA,PRICE_HIGH,i+1);
         double mal = iMA(Symbol(),0,Lb,0,MODE_SMA,PRICE_LOW ,i+1);
          Hlv[i] = Hlv[i+1];
             if(Close[i]>mah) Hlv[i] =  1;
             if(Close[i]<mal)  Hlv[i] = -1;
      
             if(Hlv[i] == -1)
                  { lo[i] = mah; hi[i] = mal; }
             else { hi[i] = mah; lo[i] = mal; }
       }
   return(0);
   }
   
   //
   //
   //
   //
   //
   
   limit = MathMax(limit,MathMin(Bars,iCustom(NULL,timeFrame,indicatorFileName,"returnBars",0,0)*timeFrame/Period()));
   
   for (i=limit; i>=0; i--)
   {
   
       int y = iBarShift(NULL,timeFrame,Time[i]);
         hi[i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",Lb,0,y); 
         lo[i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",Lb,1,y); 
    }
return(0);
}

//+-------------------------------------------------------------------
//|                                                                  
//+-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = stringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}
string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

string stringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int tchar = StringGetChar(s, length);
         if((tchar > 96 && tchar < 123) || (tchar > 223 && tchar < 256))
                     s = StringSetChar(s, length, tchar - 32);
         else if(tchar > -33 && tchar < 0)
                     s = StringSetChar(s, length, tchar + 224);
   }
   return(s);
}
      


